.586
.model flat,stdcall
option casemap:none

include windows.inc
include user32.inc
include kernel32.inc
include gdi32.inc
   
includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib

WinMain proto

MAX_LOADSTRING  EQU 100
BALL_SIZE       EQU 24
WINDOW_SIZE_X   EQU 400
WINDOW_SIZE_Y   EQU 400
WINDOW_BITS     EQU (WINDOW_SIZE_X * WINDOW_SIZE_Y)
BLUR_GRID       EQU 9
BLUR_COUNT      EQU 1

RGB_BLACK       equ 0000000h
RGB_DKGRAY      equ 0404040h
RGB_GRAY        equ 0808080h
RGB_SILVER      equ 0c0c0c0h
RGB_WHITE       equ 0ffffffh
RGB_MAROON      equ 0000080h
RGB_RED         equ 00000ffh
RGB_LEAF        equ 0008000h
RGB_GREEN       equ 000ff00h
RGB_NAVY        equ 0800000h
RGB_BLUE        equ 0ff0000h
RGB_OLIVE       equ 0008080h
RGB_YELLOW      equ 000ffffh
RGB_TEAL        equ 0808000h
RGB_CYAN        equ 0ffff00h
RGB_PURPLE      equ 0800080h
RGB_MAGENTA     equ 0ff00ffh

;easy union struct so i can get the RGB values
PixRGB UNION
    rgb DWORD ?
   STRUCT colors
        red BYTE ?
        grn BYTE ?
        blu BYTE ?
        alf BYTE ?
   ENDS
PixRGB ENDS

.data
    ClassName   db      "MainWinClass", 0
    AppName     db      "Main Window", 0
    xPos        SDWORD  -1
    yPos        SDWORD  -1
    brushColor  DWORD   0
    memBM       HBITMAP NULL
    memDC       HDC     NULL
    ActualSize  DWORD   -1   
    ActualBits  DWORD   -1
    
.data?
    hInstance   HINSTANCE ?
    diBits      COLORREF PTR ?
    diPix       PixRGB WINDOW_BITS dup(<0>)
    pt          PixRGB BLUR_GRID dup(<0>)
    
.code
start:
    invoke GetModuleHandle, NULL
    mov    hInstance, eax
    
    invoke WinMain
    invoke ExitProcess,eax

WinMain proc
	LOCAL   wc:WNDCLASSEX
	LOCAL   msg:MSG
	LOCAL   hwnd:HWND
	LOCAL   rectScreen:RECT
	LOCAL   desktopHandle:HANDLE
	LOCAL   posX:DWORD
	LOCAL   posY:DWORD
	
	;setup the basic format of the window
	mov     wc.cbSize, SIZEOF WNDCLASSEX
	mov     wc.style, CS_HREDRAW or CS_VREDRAW
	mov     wc.lpfnWndProc, OFFSET WndProc
	mov     wc.cbClsExtra, NULL
	mov     wc.cbWndExtra, NULL
	push    hInstance
	pop     wc.hInstance
	mov     wc.hIcon, NULL
	mov     wc.hCursor, NULL
	mov     wc.hbrBackground, (COLOR_WINDOW + 1)
	mov     wc.lpszClassName, OFFSET ClassName
	mov     wc.hIconSm, NULL
	mov     wc.lpszMenuName, NULL
	
	invoke  RegisterClassEx, addr wc
	
	;get the rect of the desktop
	invoke  GetDesktopWindow
	mov     desktopHandle, eax
	invoke  GetWindowRect, desktopHandle, addr rectScreen
	
	;find our windows left position so it can be centered
	mov     eax, rectScreen.right
	sub     eax, WINDOW_SIZE_X
	shr     eax, 1
	mov     posX, eax
    ;find our windows top position so it can be centered	
	mov     eax, rectScreen.bottom
	sub     eax, WINDOW_SIZE_Y
	shr     eax, 1
	mov     posY, eax
	
    invoke  CreateWindowEx, NULL, addr ClassName, addr AppName, WS_POPUPWINDOW, \
        posX, posY, WINDOW_SIZE_X, WINDOW_SIZE_Y, NULL, NULL, hInstance, NULL
           
	mov     hwnd, eax
	
	invoke  ShowWindow, hwnd, SW_SHOWNORMAL
	invoke  UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg, NULL, 0, 0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL windowRect:RECT
	LOCAL xPosStart:DWORD
	LOCAL yPosStart:DWORD
	LOCAL brush:LOGBRUSH
	LOCAL br:PTR BRUSH
	LOCAL ps:PAINTSTRUCT
	LOCAL hdc:PTR DC
	LOCAL bmi:BITMAPINFO
	LOCAL pen:PTR PEN
	LOCAL ballPosL:DWORD
	LOCAL ballPosT:DWORD
	LOCAL ballPosR:DWORD
	LOCAL ballPosB:DWORD
	LOCAL dibIndex:DWORD
	LOCAL maxIndex:DWORD
	LOCAL ptIndex:DWORD
	LOCAL blurCount:DWORD

	.IF uMsg==WM_DESTROY
	    invoke KillTimer, hWnd, 1
	    invoke DeleteObject, memBM
	    invoke ReleaseDC, hWnd, memDC
	    invoke DeleteObject, memDC
	    
		invoke PostQuitMessage, NULL
	.ELSEIF uMsg == WM_TIMER
	     ;really we are just going to invalidate the window rect so we can get another paint message
	     invoke InvalidateRect, hWnd, NULL, TRUE
	.ELSEIF uMsg==WM_CREATE
		invoke ShowCursor, FALSE
		invoke GetWindowRect, hWnd, addr windowRect
		
		;get the center X position of the window
		mov eax, windowRect.right
		sub eax, windowRect.left
		shr eax, 1
		add eax, windowRect.left
		mov xPosStart, eax
		
		;get the center Y position for the window
		mov eax, windowRect.bottom
		sub eax, windowRect.top
		shr eax, 1
		add eax, windowRect.top
		mov yPosStart, eax

		;put the cursor right in the middle of the window
		invoke SetCursorPos, xPosStart, yPosStart
		;start a simple timer so we look animated
		invoke SetTimer, hWnd, 1, 5, addr WndProc
	.ELSEIF uMsg == WM_MOUSEMOVE
	    ;we need to retain the current mouse position so we gather the information from the LOWORD and HIWORD
        mov eax, lParam
        xor edx, edx
        mov dx, ax
        shr eax, 16
        mov xPos, edx
        mov yPos, eax
    .ELSEIF uMsg == WM_RBUTTONUP
        invoke GetClientRect, hWnd, addr windowRect
        
        .if brushColor >= 4
            mov brushColor, 0
        .else
            mov eax, brushColor
            inc eax
            mov brushColor, eax 
        .endif
        
        mov brush.lbColor, 0
        mov brush.lbHatch, 0
        mov brush.lbStyle, 0
        
        invoke CreateBrushIndirect, addr brush
        mov br, eax
        invoke FillRect, memDC, addr windowRect, br
        invoke DeleteObject, br
        invoke InvalidateRect, hWnd, NULL, TRUE
    .ELSEIF uMsg == WM_ERASEBKGND
        mov eax, TRUE
        ret
    .ELSEIF uMsg == WM_PAINT
            invoke BeginPaint, hWnd, addr ps
            mov hdc, eax
            mov brush.lbHatch, 0
            mov brush.lbStyle, 0
            
            .if brushColor == 0
                mov brush.lbColor, RGB_YELLOW ;                 - yellow
            .elseif brushColor == 1
                mov brush.lbColor, 16777215 ;rgb(255, 255, 255) - white
            .elseif brushColor == 2
                mov brush.lbColor, 65280    ;rgb(0, 255, 0)     - green
            .elseif brushColor == 3
                mov brush.lbColor, 16711680 ;rgb(0, 0, 255)     - blue
            .elseif brushColor == 4
                mov brush.lbColor, 0        ;rgb(0, 0, 0)       - black
            .endif
            
            invoke CreateBrushIndirect, addr brush
            mov br, eax
            invoke SelectObject, memDC, br
            invoke DeleteObject, eax
            
            .if memDC == NULL
                invoke CreateCompatibleDC, hdc
                mov memDC, eax
            .endif
            
            invoke GetClientRect, hWnd, addr windowRect
            
            mov bmi.bmiHeader.biSize, sizeof BITMAPINFO
            mov eax, windowRect.right
            sub eax, windowRect.left
            mov bmi.bmiHeader.biWidth, eax
            mov eax, windowRect.bottom
            sub eax, windowRect.top
            mov bmi.bmiHeader.biHeight, eax
            mov bmi.bmiHeader.biPlanes, 1
            mov bmi.bmiHeader.biBitCount, 32
            mov bmi.bmiHeader.biCompression, BI_RGB
            mov bmi.bmiHeader.biSizeImage, BI_RGB
            mov bmi.bmiHeader.biYPelsPerMeter, NULL
            mov bmi.bmiHeader.biXPelsPerMeter, NULL
            mov bmi.bmiHeader.biClrUsed, NULL
            mov bmi.bmiHeader.biClrImportant, NULL
            
            .if memBM == NULL
                invoke CreateDIBSection, memDC, addr bmi, DIB_RGB_COLORS, addr diBits, NULL, NULL
                mov memBM, eax
                invoke SelectObject, memDC, memBM
                
                ;store the actual size and actual bit count of the bitmap
                mov eax, bmi.bmiHeader.biWidth
                mul bmi.bmiHeader.biHeight
                mov ActualSize, eax
                mov ebx, sizeof PixRGB
                mul ebx
                mov ActualBits, eax
            .endif
            
            .if xPos >= 0
                invoke CreatePen, PS_SOLID, 10, 16711680    ; rgb(0, 0, 255)
                mov pen, eax
                invoke SelectObject, memDC, pen

                ;ball's left coord
                mov eax, xPos
                sub eax, BALL_SIZE
                mov ballPosL, eax
                ;ball's top coord
                mov eax, yPos
                sub eax, BALL_SIZE
                mov ballPosT, eax
                ;ball's right coord
                mov eax, xPos
                add eax, BALL_SIZE
                mov ballPosR, eax
                ;ball's bottom coord
                mov eax, yPos
                add eax, BALL_SIZE
                mov ballPosB, eax
                
                ;draw the current "ball" ... which is really a substitute for the cursor
                invoke Ellipse, memDC, ballPosL, ballPosT, ballPosR, ballPosB
                invoke DeleteObject, pen
            .endif
            
            ;create the fatter cross lines
            invoke CreatePen, PS_SOLID, 8, 16750230
            mov pen, eax
            invoke SelectObject, memDC, pen
            invoke MoveToEx, memDC, 0, 0, NULL
            invoke LineTo, memDC, windowRect.right, windowRect.bottom
            invoke MoveToEx, memDC, windowRect.right, 0, NULL
            invoke LineTo, memDC, 0, windowRect.bottom
            invoke DeleteObject, pen
            
            ;create the thinner cross lines
            invoke CreatePen, PS_SOLID, 2, 16765650
            mov pen, eax
            invoke SelectObject, memDC, pen
            invoke MoveToEx, memDC, 0, 0, NULL
            invoke LineTo, memDC, windowRect.right, windowRect.bottom
            invoke MoveToEx, memDC, windowRect.right, 0, NULL
            invoke LineTo, memDC, 0, windowRect.bottom
            invoke DeleteObject, pen
    
            ;clear all the current cached rgb values. they should not all be (0)
            invoke RtlFillMemory, addr pt, BLUR_GRID * (sizeof PixRGB), 0
            
            ;what is the size of memory that we need to copy into our actual array
            invoke RtlMoveMemory, addr diPix, diBits, ActualBits
            
            mov eax, BLUR_COUNT
            .if eax > 0
                mov blurCount, 0
                blur_loop:
                    ;ecx - used as the actual byte offset for the rgb bytes
                    ;start this at the safest first member so we can attempt to get a good blur from the surrounding colors.
                    mov ecx, bmi.bmiHeader.biWidth
                    inc ecx
                    shl ecx, 2
                    
                    ;we are not going to use any pixels on the bottom row. just make them black                    
                    mov eax, bmi.bmiHeader.biWidth
                    inc eax
                    shl eax, 2
                    push eax
                    invoke RtlFillMemory, addr diPix, eax, 0
                    pop eax
                    mov ebx, ActualSize
                    sub ebx, bmi.bmiHeader.biWidth
                    dec ebx
                    shl ebx, 2
                    add ebx, offset diPix
                    invoke RtlFillMemory, ebx, eax, 0 
                    
                    ;start the index after the bottom row
                    mov eax, bmi.bmiHeader.biWidth
                    mov dibIndex, eax
                    
                    pix_loop:
                        ;calculate the first array element we'll be referencing.
                        mov eax, bmi.bmiHeader.biWidth
                        add eax, 1
                        shl eax, 2
                        
                        .if ecx > eax
                            ;calculate the last array element we'll be referencing.
                            mov eax, ActualSize
                            sub eax, bmi.bmiHeader.biWidth
                            dec eax
                            shl eax, 2
                            
                            ;make sure what we are not trying to work with anything larger than our safest large member.
                            ;this is because this loop will only use members that will give us surrounding colors.
                            .if ecx < eax
                                ;find the first upper left member
                                mov eax, bmi.bmiHeader.biWidth
                                dec eax
                                shl eax, 2
                                add eax, ecx
                                
                                ;upper left
                                mov ebx, diPix[eax]
                                mov pt, ebx
                                ;upper
                                mov ebx, diPix[eax + 4]
                                mov pt[4], ebx
                                ;upper right
                                mov ebx, diPix[eax + 8]
                                mov pt[8], ebx
                                ;left
                                mov ebx, diPix[ecx + 4]
                                mov pt[12], ebx
                                ;origin
                                mov ebx, diPix[ecx]
                                mov pt[16], ebx
                                ;left
                                mov ebx, diPix[ecx - 4]
                                mov pt[20], ebx
                                 
                                ;calculate the lower left member
                                mov eax, bmi.bmiHeader.biWidth
                                inc eax
                                shl eax, 2
                                mov ebx, eax
                                mov eax, ecx
                                sub eax, ebx
                                
                                ;lower left
                                mov ebx, diPix[eax]
                                mov pt[24], ebx
                                ;lower
                                mov ebx, diPix[eax + 4]
                                mov pt[28], ebx
                                ;lower right
                                mov ebx, diPix[eax + 8]
                                mov pt[32], ebx
                                
                                comment *
                                    basically we are going to use the points that we have collected
                                    from the above calculations to get the surrounding colors and
                                    we average them together. we need to get an average of the red,
                                    green, and blue all seperate from each other. once we have the
                                    average we just set the current pixel color to the color as 
                                    calculated. this should give a blur effect.
                                *
                                
                                xor ebx, ebx
                                
                                xor eax, eax
                                mov al, pt[0].colors.red
                                add ebx, eax
                                mov al, pt[4].colors.red
                                add ebx, eax
                                mov al, pt[8].colors.red
                                add ebx, eax
                                mov al, pt[12].colors.red
                                add ebx, eax
                                ;mov al, pt[16].colors.red    ;for some reason we are not able to use 
                                ;add ebx, eax                 ;all the pixels and can only div by 8
                                mov al, pt[20].colors.red
                                add ebx, eax
                                mov al, pt[24].colors.red
                                add ebx, eax
                                mov al, pt[28].colors.red
                                add ebx, eax
                                mov al, pt[32].colors.red
                                add ebx, eax
                                    
                                mov eax, ebx
                                ;shr eax, 1
                                mov ebx, 8
                                div ebx
                                
                                ;set the red color average
                                mov diPix[ecx].colors.red, al
                                        
                                xor ebx, ebx
                                
                                xor eax, eax
                                mov al, pt[0].colors.grn
                                add ebx, eax
                                mov al, pt[4].colors.grn
                                add ebx, eax
                                mov al, pt[8].colors.grn
                                add ebx, eax
                                mov al, pt[12].colors.grn
                                add ebx, eax
                                ;mov al, pt[16].colors.grn
                                ;add ebx, eax
                                mov al, pt[20].colors.grn
                                add ebx, eax
                                mov al, pt[24].colors.grn
                                add ebx, eax
                                mov al, pt[28].colors.grn
                                add ebx, eax
                                mov al, pt[32].colors.grn
                                add ebx, eax
                                
                                mov eax, ebx
                                ;shr eax, 1
                                mov ebx, 8
                                div ebx
                                
                                ;set the green color average
                                mov diPix[ecx].colors.grn, al
                                
                                xor ebx, ebx
                                
                                xor eax, eax
                                mov al, pt[0].colors.blu
                                add ebx, eax
                                mov al, pt[4].colors.blu
                                add ebx, eax
                                mov al, pt[8].colors.blu
                                add ebx, eax
                                mov al, pt[12].colors.blu
                                add ebx, eax
                                ;mov al, pt[16].colors.blu
                                ;add ebx, eax
                                mov al, pt[20].colors.blu
                                add ebx, eax
                                mov al, pt[24].colors.blu
                                add ebx, eax
                                mov al, pt[28].colors.blu
                                add ebx, eax
                                mov al, pt[32].colors.blu
                                add ebx, eax
                                
                                mov eax, ebx
                                ;shr eax, 1
                                mov ebx, 8
                                div ebx
                                
                                ;set the blue color average
                                mov diPix[ecx].colors.blu, al
                            .endif 
                        .endif
                
                        ;increase the btye offset so we can go to the next pixel
                        add ecx, 4
                        
                        ;increase the index count so we know what index we are on.
                        mov eax, dibIndex
                        inc eax
                        mov dibIndex, eax
                        
                        ;check to see if we are at the end of the byte array
                        cmp eax, ActualSize
                    jnz pix_loop
                    
                    ;increase the blur count so we know how many times we need to blur the image
                    add blurCount, 1
                    mov eax, blurCount
                    
                    ;see if we are at the end of our blur count
                    cmp eax, BLUR_COUNT
                jnz blur_loop
            .endif
            
            ;move the rgb bits back to the memory bitmap
            invoke RtlMoveMemory, diBits, addr diPix, ActualBits
            invoke BitBlt, hdc, 0, 0, bmi.bmiHeader.biWidth, bmi.bmiHeader.biHeight, memDC, 0, 0, SRCCOPY
            invoke EndPaint, hWnd, addr ps
            
            mov eax, TRUE
            ret
	.ELSE
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam		
		ret
	.ENDIF
	
	xor eax,eax
	ret
WndProc endp

end start